//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DefautJaugeMat.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck est utilis est utilis pour tre sr que les composants crs n'ont
// aucune fonction virtuelle pure.
//

static inline void ValidCtrCheck(TDefautJaugeMat *Jauge)
{
  new TDefautJaugeMat(NULL);
}
//---------------------------------------------------------------------------
__fastcall TDefautJaugeMat::TDefautJaugeMat(TComponent* Owner)
  : TGraphicControl(Owner)
{
  FIcone = new TIcon;
  FBitmap = new Graphics::TBitmap;
  FCoulBarre = clBlue;
  FPosition = 0;
  FMax = 100;
  FTexture = false;
  Width = 110;
  Height = 40;
  Font->Name = "Tahoma";
  Font->Size= 7;
  Font->Color = clBlack;
}
//---------------------------------------------------------------------------
namespace Defautjaugemat
{
  void __fastcall PACKAGE Register()
  {
     TComponentClass classes[1] = {__classid(TDefautJaugeMat)};
     RegisterComponents("Ma palette", classes, 0);
  }
}
//---------------------------------------------------------------------------
__fastcall TDefautJaugeMat::~TDefautJaugeMat()
  {
  delete FIcone;
  FIcone = NULL;
  delete FBitmap;
  FBitmap = NULL;
  }

void __fastcall TDefautJaugeMat::SetIcone(TIcon *AIcone)
  {
  FIcone->Assign(AIcone);
  Repaint();
  }

void __fastcall TDefautJaugeMat::SetCoulBarre(const TColor ACoulBarre)
  {
  if (ACoulBarre != FCoulBarre)
    {
    FCoulBarre = ACoulBarre;
    Repaint();
    }
  }

void __fastcall TDefautJaugeMat::SetBitmap(Graphics::TBitmap *ABitmap)
  {
	  FBitmap->Assign(ABitmap);
    FTexture = FTexture && !(FBitmap->Empty);
    Repaint();
  }

void __fastcall TDefautJaugeMat::SetPosition (int APosition)
  {
  if (APosition != FPosition)
    {
    if (APosition < FMax)
      FPosition = APosition;
    else
      FPosition = FMax;
    Repaint();
    }
  }

void __fastcall TDefautJaugeMat::SetMax(int AMax)
  {
  if (AMax != FMax)
    {
    FMax = AMax;
    if (FPosition > FMax)
      FPosition = FMax;
    Repaint();
    }
  }

void __fastcall TDefautJaugeMat::SetTexture(bool ATexture)
  {
  if (FBitmap->Empty)
    FTexture = false;
  else
    FTexture = ATexture;
  Repaint();
  }

void __fastcall TDefautJaugeMat::SetPourcent(bool APourcent)
  {
  if (FPourcent != APourcent)
    {
    FPourcent = APourcent;
    Repaint();
    }
  }

void __fastcall TDefautJaugeMat::SetLabel(AnsiString ALabel)
  {
  if (FLabel != ALabel)
    {
    FLabel = ALabel;
    Repaint();
    }
  }

void __fastcall TDefautJaugeMat::SetCapa(AnsiString ACapa)
  {
  if (FCapa != ACapa)
    {
    FCapa = ACapa;
    Repaint();
    }
  }

void __fastcall TDefautJaugeMat::SetLibre(AnsiString ALibre)
  {
  if (FLibre != ALibre)
    {
    FLibre = ALibre;
    Repaint();
    }
  }

// Fonction de dessin du composant
void __fastcall TDefautJaugeMat::Paint(void)
  {
  int Gauche, Haut;
  int LargeurCible, LargeurSource;
  AnsiString Pourcentage;
  Graphics::TBitmap *BmpTemp;
  TRect Dest, Source;

  // dessin du cadre extrieur

  Canvas->Pen->Color = clBtnShadow;
  Canvas->MoveTo(0, Height - 1);
  Canvas->LineTo(0, 0);
  Canvas->LineTo(Width - 1, 0);
  Canvas->Pen->Color = clBtnHighlight;
  Canvas->LineTo(Width - 1, Height - 1);
  Canvas->LineTo(0, Height - 1);

  // dessin du cadre intrieur

  Canvas->MoveTo(1, Height - 2);
  Canvas->LineTo(1, 1);
  Canvas->LineTo(Width - 2, 1);
  Canvas->Pen->Color = clBtnShadow;
  Canvas->LineTo(Width - 2, Height - 2);
  Canvas->LineTo(1, Height - 2);

  // Dessin de l'icne
  if (FIcone != NULL)
    Canvas->Draw(3,3, FIcone);

  // Slection de la police
  Canvas->Brush->Style = bsClear;
  Canvas->Font->Name = Font->Name;
  Canvas->Font->Size= Font->Size;
  Canvas->Font->Color = Font->Color;

  // Affichage du nom du lecteur
  Canvas->TextOut(22, 3, FLabel);

  // Affichage de l'espace libre
  Canvas->TextOut(22, 12, FLibre);

  // Affichage de la capacit
  Gauche = Width - 4 - Canvas->TextWidth(FCapa);
  Canvas->TextOut(Gauche, 12, FCapa);

  // Dessin du cadre de la jauge
  Canvas->Pen->Color = clBtnShadow;
  Canvas->MoveTo(4, Height - 4);
  Canvas->LineTo(4, 23);
  Canvas->LineTo(Width - 5, 23);
  Canvas->Pen->Color = clBtnHighlight;
  Canvas->LineTo(Width - 5, Height - 4);
  Canvas->LineTo(4, Height - 4);

  // Dessin de la jauge
  LargeurCible = (Width - 6 - 5) * FPosition / FMax;
  if (FTexture)
    {
    LargeurSource = (FBitmap->Width - 1) * FPosition / FMax;
    Canvas->CopyRect(Rect(5, 24, 5 + LargeurCible, Height - 4), FBitmap->Canvas,
        Rect(0, 0, LargeurSource, FBitmap->Height - 1));
    }
  else
    {
    Canvas->Brush->Style = bsSolid;
    Canvas->Brush->Color= FCoulBarre;
    Canvas->Pen->Color = FCoulBarre;
    Canvas->Rectangle(5, 24, 5 + LargeurCible, Height - 4);
    }

  // Affichage du %
  if (FPourcent)
    {
    BmpTemp = new Graphics::TBitmap();
    // Slection de la police
    BmpTemp->Canvas->Brush->Style = bsSolid;
    BmpTemp->Canvas->Brush->Color = clBlack;
    BmpTemp->Canvas->Font->Color = clWhite;
    BmpTemp->Canvas->Font->Name = Font->Name;
    BmpTemp->Canvas->Font->Size = Font->Size;

    // Configuration du tampon
    Pourcentage = IntToStr((int)(FPosition * 100 / FMax)) + "%";
    BmpTemp->Width = BmpTemp->Canvas->TextWidth(Pourcentage);
    BmpTemp->Height = Canvas->TextHeight(Pourcentage);
    BmpTemp->Canvas->TextOut(0, 0, Pourcentage);

    Source = Rect(0, 0, BmpTemp->Width, BmpTemp->Height);
    Gauche = (Width - 2 * 5 - BmpTemp->Width) / 2 + 5;
    Haut = (Height - 6 - 26 - BmpTemp->Height) / 2 + 26;
    Dest = Rect(Gauche, Haut, Gauche + BmpTemp->Width, Haut + BmpTemp->Height);

    Canvas->CopyMode = cmSrcInvert;
    Canvas->CopyRect(Dest, BmpTemp->Canvas, Source);
    Canvas->CopyMode = cmSrcCopy;

    delete BmpTemp;
    }
  }
//---------------------------------------------------------------------------
